#define _WIN32_IE     0x0500

#ifdef __POCC__
#define _WIN32_WINNT  0x0500
#else
#define _WIN32_WINNT  0x0400
#endif

#include <hbapi.h>
#include <winsock.h>
#include <time.h>

#define MAXLEN 1024

#include <windows.h>

#include <commctrl.h>

#include <richedit.h>

#include "hbapiitm.h"
#include "hbapifs.h"
#include <shellapi.h>
#include <shlobj.h>
#include <shlwapi.h>
#include <lmcons.h>


#if defined ( __MINGW32__ ) && ( _WIN32_WINNT < 0x0500 )
#define IMF_AUTOFONT      0x0002
#endif

#if defined ( __WATCOMC__ )
#define ENM_DRAGDROPDONE  0x00000010
#define SF_USECODEPAGE    0x0020          /* CodePage given by high word */
#endif

#if defined( MSFTEDIT_CLASS )
#undef MSFTEDIT_CLASS
#endif
#define MSFTEDIT_CLASS    "RICHEDIT50W"

#ifdef __XHARBOUR__
#define HB_STORC( n, x, y )   hb_storc( n, x, y )
#define HB_STORL( n, x, y )   hb_storl( n, x, y )
#define HB_STORNI( n, x, y )  hb_storni( n, x, y )
#define HB_STORNL( n, x, y )  hb_stornl( n, x, y )
#else
#define HB_STORC( n, x, y )   hb_storvc( n, x, y )
#define HB_STORL( n, x, y )   hb_storvl( n, x, y )
#define HB_STORNI( n, x, y )  hb_storvni( n, x, y )
#define HB_STORNL( n, x, y )  hb_storvnl( n, x, y )
#endif


HB_FUNC( GETSELRANGE )                             //GetSelRange(HWND hwndCtrl)
{
   CHARRANGE   cRange;

   SendMessage( (HWND) hb_parnl(1), (UINT) EM_EXGETSEL, 0, (LPARAM) & cRange );

   hb_reta( 2 );
   HB_STORNL( cRange.cpMin, -1, 1 );
   HB_STORNL( cRange.cpMax, -1, 2 );
}

HB_FUNC ( GETDESKTOPAREA ) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_reta(4);
	HB_STORNI((INT) rect.top, -1, 1);
	HB_STORNI((INT) rect.left, -1, 2);
	HB_STORNI((INT) rect.right - rect.left, -1, 3);
	HB_STORNI((INT) rect.bottom - rect.top, -1, 4);
}

HB_FUNC( GETDESKTOPRECTWIDTH )
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 0, &rect, 0 );
	hb_retni(rect.right - rect.left);
}

HB_FUNC( GETDESKTOPRECTHEIGHT )
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 0, &rect, 0 );
	hb_retni(rect.bottom - rect.top);
}

HB_FUNC (GETDESKTOPREALTOP) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_retni(rect.top);

}
HB_FUNC (GETDESKTOPREALLEFT) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_retni(rect.left);

}

HB_FUNC (GETDESKTOPREALWIDTH) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_retni(rect.right - rect.left);

}

HB_FUNC (GETDESKTOPREALHEIGHT) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_retni(rect.bottom - rect.top);
}

HB_FUNC( PEGAINATIVIDADE ) 
{
   LASTINPUTINFO lpi;
   lpi.cbSize = sizeof (LASTINPUTINFO);
   GetLastInputInfo (&lpi);
   hb_retnd( ( DOUBLE ) ( GetTickCount() - lpi.dwTime ) / CLOCKS_PER_SEC ); 
}

//HB_FUNC( SIMULAENTER )
//{
//  //SetForegroundWindow( ( HWND ) hb_parnl( 1 ) );
//
//  keybd_event(
//      VK_RETURN,
//      0,
//      0,
//      0
//      );
//}

HB_FUNC( FINDWINDOW )
{
   hb_retnl( ( LONG ) FindWindow( 0, hb_parc( 1 ) ) );
}

HB_FUNC( SETFOREGROUNDWINDOW2 )
{
   SetForegroundWindow( ( HWND ) hb_parnl( 1 ) );
}

HB_FUNC( HB_OEMTOANSI )
{
   hb_retc( "" );
}

//HB_FUNC( PEGAINATIVIDADE ) 
//{
//   typedef struct tagLASTINPUTINFO
//   {
//       UINT cbSize;
//       DWORD dwTime;
//   } LASTINPUTINFO, *PLASTINPUTINFO;
//
//   WINUSERAPI BOOL WINAPI GetLastInputInfo(PLASTINPUTINFO);
//   typedef  BOOL (WINAPI *GETLASTINPUTINFO_)(PLASTINPUTINFO);
//
//   HINSTANCE handle= LoadLibrary("user32.dll");
//   if ( handle)
//   {
//      GETLASTINPUTINFO_ pFunc;
//      pFunc = GetProcAddress( handle,"GetLastInputInfo" );
//      if (pFunc)
//      {
//         LASTINPUTINFO lpi;
//    
//         lpi.cbSize = sizeof(LASTINPUTINFO);
//
//         if (!pFunc(&lpi))
//         {
//            hb_retni(0);
//         }
//         else
//         {
//            hb_retnd( ( DOUBLE ) ( GetTickCount() - lpi.dwTime ) * 0.001 ); 
//         }
//      }
//   else
//   {
//      hb_retni(0);
//   }
//   }
//
//   if (handle)
//   {
//      FreeLibrary( handle);
//   }
//}